#include "parser.h"

Parser::Parser(char *entireMessage, char *emailDir)
{

	char *fromAddress = getFromAddress(entireMessage);
//	char *toAddress = getToAddress(entireMessage);
	char *subject = getSubject(entireMessage);
	char *replyToAddress = getReplyToAddress(entireMessage);

//	entireMessage = unEscape(entireMessage);

	char *fileName = getFileName(emailDir, fromAddress);
	
	writeToFile(entireMessage, fileName);

	setFileType(fileName);

	addAttr("MAIL:from", fromAddress, fileName);
//	addAttr("MAIL:to", toAddress, fileName);
	addAttr("MAIL:reply", replyToAddress, fileName);
	addAttr("MAIL:subject", subject, fileName);
	addAttr("MAIL:status", "New", fileName);
	
	delete[] fileName;
	
	delete[] fromAddress;
//	delete[] toAddress;
	delete[] subject;
	delete[] replyToAddress;
}

Parser::~Parser()
{
	return;
}

char *Parser::getFromAddress(char *entireMessage)
{
	char *startFromAddress;
	char *endFromAddress;
	
	if((startFromAddress = strstr(entireMessage, "From: ")))
	{
		startFromAddress += 6;
		endFromAddress = strchr(startFromAddress, '\r');
		endFromAddress[0] = '\0';
	
		char *fromAddress = new char[strlen(startFromAddress) + 1];
		strcpy(fromAddress, startFromAddress);
		
		endFromAddress[0] = '\r';

		return fromAddress;
	}
	else
	{
		char *fromAddress = new char[16];
		strcpy(fromAddress, "Unknown fromAddress");
		return fromAddress;
	}
}
char *Parser::getToAddress(char *entireMessage)
{
	char *startToAddress;
	char *endToAddress;
	
	if((startToAddress = strstr(entireMessage, "To: ")))
	{
		startToAddress += 4;
		endToAddress = strchr(startToAddress, '\r');
		endToAddress[0] = '\0';
	
		char *toAddress = new char[strlen(startToAddress) + 1];
		strcpy(toAddress, startToAddress);
		
		endToAddress[0] = '\r';

		return toAddress;
	}
	else
	{
		char *toAddress = new char[16];
		strcpy(toAddress, "Unknown toAddress");
		return toAddress;
	}
}

char *Parser::getReplyToAddress(char *entireMessage)
{
	char *startReplyToAddress;
	char *endReplyToAddress;
	
	if((startReplyToAddress = strstr(entireMessage, "Reply-To: ")))
	{
		startReplyToAddress += 10;
		endReplyToAddress = strchr(startReplyToAddress, '\r');
		endReplyToAddress[0] = '\0';
	
		char *replyToAddress = new char[strlen(startReplyToAddress) + 1];
		strcpy(replyToAddress, startReplyToAddress);
		
		endReplyToAddress[0] = '\r';

		return replyToAddress;
	}
	else
	{
		char *replyToAddress = new char[16];
		strcpy(replyToAddress, "Unknown replyToAddress");
		return replyToAddress;
	}
}

char *Parser::getSubject(char *entireMessage)
{
	char *startSubject;
	char *endSubject;
	
	if((startSubject = strstr(entireMessage, "Subject: ")))
	{
		startSubject += 9;
		endSubject = strchr(startSubject, '\r');
		endSubject[0] = '\0';
	
		char *subject = new char[strlen(startSubject) + 1];
		strcpy(subject, startSubject);
		
		endSubject[0] = '\r';

		return subject;
	}
	else
	{
		char *subject = new char[16];
		strcpy(subject, "Unknown Subject");
		return subject;
	}
}

char *Parser::getFileName(char *emailDir, char *fromAddress)
{
	char *fileName = new char[strlen(emailDir) + strlen(fromAddress) + 14];
	int k = 0;
	do
	{
		sprintf(fileName, "%s%s%ld_%i", emailDir, fromAddress, time(NULL), k);

		if(fileExists(fileName))
			k++;
		else
			k = 0;
	}while(k);		
	
	return fileName;
}

bool Parser::addAttr(char *attrName, char *attrValue, char *fileName)
{
	if(strlen(attrValue))
	{
		char *addAttr = new char[strlen(attrName) + strlen(attrValue) + strlen(fileName) + 15];
		memset(addAttr, '\0', (strlen(attrName) + strlen(attrValue) + strlen(fileName) + 15));
		sprintf(addAttr, "addattr %s \"%s\" \"%s\"", attrName, attrValue, fileName);
		system(addAttr);
		delete[] addAttr;
		return 1;
	}

	return 0;
}

char *Parser::unEscape(char *entireMessage)
{
	char *newEntireMessage = new char[strlen(entireMessage) + 1];
	memset(newEntireMessage, '\0', strlen(entireMessage) + 1);
	char *toConvert = new char[3];
	int j = 0;
	
	for(int k = 0; k < strlen(entireMessage); k++)
	{
		if((entireMessage[k] == '=') 
			&& isHexish(entireMessage[k + 1])
			&& isHexish(entireMessage[k + 2]))
		{
			toConvert[0] = entireMessage[++k];
			toConvert[1] = entireMessage[++k];
			long newCh = strtol(toConvert, (char **)NULL, 16);
			newEntireMessage[j] = char(newCh);
		}
		else 
			newEntireMessage[j] = entireMessage[k];
		j++;
	}

	delete[] toConvert;
	delete[] entireMessage;
	
	return newEntireMessage;
}

bool Parser::isHexish(char ch)
{
	if((ch > 47 && ch < 58) 
		|| (ch > 64 && ch < 71) 
		|| (ch > 96 && ch < 103))
		return 1;
	else
		return 0;
}

bool Parser::fileExists(char *fileName)
{
	ifstream inFile;
	inFile.open(fileName);
	
	if(inFile)
	{
		inFile.close();
		return 1;
	}
	else
	{
		inFile.close();
		return 0;
	}
}

bool Parser::writeToFile(char *entireMessage, char *fileName)
{
	ofstream outFile;
	outFile.open(fileName);
	
	outFile << entireMessage;
	
	outFile.close();
	
	return 1;
}

bool Parser::setFileType(char *fileName)
{
	char *setFileType = new char[strlen(fileName) + 23];
	memset(setFileType, '\0', (strlen(fileName) + 23));
	sprintf(setFileType, "settype -t text/x-email %s", fileName);
	system(setFileType);
	delete[] setFileType;
	
	return 1;
}
