#include "sockets.h"

Sockets::Sockets(char *hostName, int portNumber)
{
	serverAddress.sin_family = AF_INET;
	serverAddress.sin_port = htons(portNumber);

	hostent *hostAddress = gethostbyname(hostName);
	serverAddress.sin_addr.s_addr = *(uint32 *)hostAddress->h_addr;

	// clear serverAddress.sin_zero - I don't know why
	memset(serverAddress.sin_zero, 0, sizeof(serverAddress.sin_zero));

	tcpSocket = socket(AF_INET, SOCK_STREAM, 0);
	if(tcpSocket < 0)
		cout << "Error: tcpSocket not created.\n";
}

Sockets::~Sockets()
{
	closesocket(tcpSocket);
}	

int Sockets::connectServer()
{
	int k = connect(tcpSocket, (struct sockaddr *)&serverAddress, sizeof(serverAddress));
	if(k < 0)
	{
		cout << "Error: connectServer() failed.\n";
		return 0;
	}

	return 1;
}

ssize_t Sockets::recvStream(char *recvBuffer, int bufferSize)
{
	memset(recvBuffer, '\0', bufferSize);
	ssize_t k = recv(tcpSocket, recvBuffer, bufferSize, 0); 
	if(k < 0)
	{
		cout << "Error: recvStream() failed.\n";
		return 0;
	}
	
	return k;
}

ssize_t Sockets::sendStream(char *sendBuffer)
{
	ssize_t k = send(tcpSocket, sendBuffer, strlen(sendBuffer), 0);
	if(k < 0)
	{
		cout << "Error: sendStream() failed.\n";
		return 0;
	}
	
	return k;
}

bool Sockets::streamWaiting() 
{ 
	timeval tv; 
	fd_set fds; 

	tv.tv_sec = 2; 
	tv.tv_usec = 0; 

	FD_ZERO(&fds); 

	FD_SET(tcpSocket, &fds); 
	select(tcpSocket + 1, &fds, NULL, NULL, &tv); 

	return FD_ISSET(tcpSocket, &fds); 
}
